<?php
namespace FiloBlu\Storelocator\Block\PickUpInStore;

class ConfirmReceived extends \Magento\Framework\View\Element\Template
{
    protected $helper;
    protected $_coreRegistry;
    protected $_storeManager;
    protected $request;

    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \FiloBlu\Storelocator\Helper\Data $helper,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\App\Request\Http $request
    )
    {
        parent::__construct($context);
        $this->helper = $helper;
        $this->_coreRegistry = $registry;
        $this->_storeManager = $context->getStoreManager();
        $this->request = $request;
    }

    public function isAlreadyConfirmed() {
      return $this->_coreRegistry->registry("pickupinstore_order_confirm_received")->getPickupInStoreConfirmReceivedDate() != null;
    }

    public function getBaseUrl() {
      return $this->_storeManager->getStore()->getBaseUrl();
    }

    public function getParams() {
      if ($params = $this->getRequest()->getParams()) {
        $increment_id = isset($params["increment_id"]) ? $params["increment_id"] : "";
        $hash = isset($params["hash"]) ? $params["hash"] : "";
        return "increment_id=" . $increment_id . "&hash=" . $hash;
      }
      else {
        return "";
      }

    }
}
